"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var h_map_methods_1 = require("./mixins/h-map-methods");
var cache_1 = require("./utils/cache");
var get_link_1 = require("./utils/get-link");
var get_platform_1 = require("./utils/get-platform");
var get_script_map_1 = require("./utils/get-script-map");
var React = require("react");
// export the HEREMap React Component from this module
var HEREMap = (function (_super) {
    __extends(HEREMap, _super);
    function HEREMap() {
        _super.apply(this, arguments);
    }
    HEREMap.prototype.componentDidMount = function () {
        var _this = this;
        var hidpi = this.props.hidpi;
        cache_1.getScriptStub("mapEventsScript").onLoad(function (err, tag) {
            var _a = _this.props, appId = _a.appId, appCode = _a.appCode, center = _a.center, zoom = _a.zoom;
            // get the platform to base the maps on
            var platform = get_platform_1.default({
                app_code: appCode,
                app_id: appId,
            });
            var defaultLayers = platform.createDefaultLayers({
                ppi: hidpi ? 320 : 72,
            });
            var map = new H.Map(document.getElementById("mapContainer"), defaultLayers.normal.map, {
                zoom: zoom,
                center: center,
                pixelRatio: hidpi ? 2 : 1,
            });
            // make the map interactive
            // MapEvents enables the event system
            // Behavior implements default interactions for pan/zoom
            var behavior = new H.mapevents.Behavior(new H.mapevents.MapEvents(map));
            // create the default UI for the map
            var ui = H.ui.UI.createDefault(map, defaultLayers);
            // attach the map object to the component"s state
            _this.setState({
                behavior: behavior,
                map: map,
                ui: ui,
            });
        });
    };
    HEREMap.prototype.componentWillMount = function () {
        cache_1.default(get_script_map_1.default());
        var stylesheetUrl = "http://js.api.here.com/v3/3.0/mapsjs-ui.css";
        get_link_1.default(stylesheetUrl, "HERE Maps UI");
    };
    HEREMap.prototype.render = function () {
        return (React.createElement("div", null, 
            React.createElement("div", {id: "mapContainer", style: { height: "100%" }})
        ));
    };
    HEREMap = __decorate([
        h_map_methods_1.default
    ], HEREMap);
    return HEREMap;
}(React.Component));
exports.HEREMap = HEREMap;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = HEREMap;
